Index: squid/src/forward.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/forward.c,v
retrieving revision 1.1.1.3.12.1
retrieving revision 1.1.1.3.12.2
diff -u -r1.1.1.3.12.1 -r1.1.1.3.12.2
--- squid/src/forward.c	14 Apr 2000 23:09:53 -0000	1.1.1.3.12.1
+++ squid/src/forward.c	17 Apr 2000 00:13:09 -0000	1.1.1.3.12.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: forward.c,v 1.1.1.3.12.1 2000/04/14 23:09:53 hno Exp $
+ * $Id: forward.c,v 1.1.1.3.12.2 2000/04/17 00:13:09 hno Exp $
  *
  * DEBUG: section 17    Request Forwarding
  * AUTHOR: Duane Wessels
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -68,6 +68,9 @@
     int sfd;
     debug(17, 3) ("fwdStateFree: %p\n", fwdState);
     assert(e->mem_obj);
+#if URL_CHECKSUM_DEBUG
+    assert(e->mem_obj->chksum == url_checksum(e->mem_obj->url));
+#endif
     if (e->store_status == STORE_PENDING) {
 	if (e->mem_obj->inmem_hi == 0) {
 	    assert(fwdState->err);
@@ -108,7 +111,7 @@
 	return 0;
     if (fwdState->n_tries > 10)
 	return 0;
-    if (squid_curtime - fwdState->start > 120)
+    if (squid_curtime - fwdState->start > Config.Timeout.connect)
 	return 0;
     if (fwdState->flags.dont_retry)
 	return 0;
@@ -202,6 +205,12 @@
 	err->request = requestLink(fwdState->request);
 	err->xerrno = ETIMEDOUT;
 	fwdFail(fwdState, err);
+	/*
+	 * This marks the peer DOWN ... 
+	 */
+	if (fwdState->servers)
+	    if (fwdState->servers->peer)
+		peerCheckConnectStart(fwdState->servers->peer);
     }
     comm_close(fd);
 }
@@ -239,6 +248,9 @@
 	fwdConnectDone(fd, COMM_OK, fwdState);
 	return;
     }
+#if URL_CHECKSUM_DEBUG
+    assert(fwdState->entry->mem_obj->chksum == url_checksum(url));
+#endif
     fd = comm_open(SOCK_STREAM,
 	0,
 	Config.Addrs.tcp_outgoing,
@@ -368,6 +380,9 @@
     http_status s;
     assert(e->store_status == STORE_PENDING);
     assert(e->mem_obj);
+#if URL_CHECKSUM_DEBUG
+    assert(e->mem_obj->chksum == url_checksum(e->mem_obj->url));
+#endif
     debug(17, 3) ("fwdReforward: %s?\n", storeUrl(e));
     if (!EBIT_TEST(e->flags, ENTRY_FWD_HDR_WAIT)) {
 	debug(17, 3) ("fwdReforward: No, ENTRY_FWD_HDR_WAIT isn't set\n");
@@ -434,6 +449,9 @@
     debug(17, 3) ("fwdStart: '%s'\n", storeUrl(e));
     e->mem_obj->request = requestLink(r);
     e->mem_obj->fd = fd;
+#if URL_CHECKSUM_DEBUG
+    assert(e->mem_obj->chksum == url_checksum(e->mem_obj->url));
+#endif
     if (shutting_down) {
 	/* more yuck */
 	err = errorCon(ERR_SHUTTING_DOWN, HTTP_SERVICE_UNAVAILABLE);
@@ -478,6 +496,9 @@
     int rc = 0;
     if (mem == NULL)
 	return 0;
+#if URL_CHECKSUM_DEBUG
+    assert(e->mem_obj->chksum == url_checksum(e->mem_obj->url));
+#endif
 #if DELAY_POOLS
     if (fd < 0)
 	(void) 0;
@@ -551,6 +572,9 @@
     assert(e->store_status == STORE_PENDING);
     debug(17, 3) ("fwdComplete: %s\n\tstatus %d\n", storeUrl(e),
 	e->mem_obj->reply->sline.status);
+#if URL_CHECKSUM_DEBUG
+    assert(e->mem_obj->chksum == url_checksum(e->mem_obj->url));
+#endif
     fwdLogReplyStatus(fwdState->n_tries, e->mem_obj->reply->sline.status);
     if (fwdReforward(fwdState)) {
 	debug(17, 3) ("fwdComplete: re-forwarding %d %s\n",
Index: squid/src/fqdncache.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fqdncache.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.10.1
diff -u -r1.1.1.3 -r1.1.1.3.10.1
--- squid/src/fqdncache.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/fqdncache.c	17 Apr 2000 00:13:10 -0000	1.1.1.3.10.1
@@ -1,7 +1,7 @@
 
 
 /*
- * $Id: fqdncache.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: fqdncache.c,v 1.1.1.3.10.1 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 35    FQDN Cache
  * AUTHOR: Harvest Derived
@@ -13,10 +13,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/ftp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ftp.c,v
retrieving revision 1.1.1.3.4.1.2.1
retrieving revision 1.1.1.3.4.1.2.2
diff -u -r1.1.1.3.4.1.2.1 -r1.1.1.3.4.1.2.2
--- squid/src/ftp.c	14 Apr 2000 23:09:53 -0000	1.1.1.3.4.1.2.1
+++ squid/src/ftp.c	17 Apr 2000 00:13:10 -0000	1.1.1.3.4.1.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ftp.c,v 1.1.1.3.4.1.2.1 2000/04/14 23:09:53 hno Exp $
+ * $Id: ftp.c,v 1.1.1.3.4.1.2.2 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 9     File Transfer Protocol (FTP)
  * AUTHOR: Harvest Derived
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/globals.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/globals.h,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.12.1
diff -u -r1.1.1.3 -r1.1.1.3.12.1
--- squid/src/globals.h	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/globals.h	17 Apr 2000 00:13:10 -0000	1.1.1.3.12.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: globals.h,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: globals.h,v 1.1.1.3.12.1 2000/04/17 00:13:10 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -10,10 +10,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/gopher.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/gopher.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.10.1
diff -u -r1.1.1.3 -r1.1.1.3.10.1
--- squid/src/gopher.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/gopher.c	17 Apr 2000 00:13:10 -0000	1.1.1.3.10.1
@@ -1,7 +1,7 @@
 
 
 /*
- * $Id: gopher.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: gopher.c,v 1.1.1.3.10.1 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 10    Gopher
  * AUTHOR: Harvest Derived
@@ -13,10 +13,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/htcp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/htcp.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.10.1
diff -u -r1.1.1.2 -r1.1.1.2.10.1
--- squid/src/htcp.c	26 Jan 2000 03:25:01 -0000	1.1.1.2
+++ squid/src/htcp.c	17 Apr 2000 00:13:10 -0000	1.1.1.2.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: htcp.c,v 1.1.1.2 2000/01/26 03:25:01 hno Exp $
+ * $Id: htcp.c,v 1.1.1.2.10.1 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 31    Hypertext Caching Protocol
  * AUTHOR: Duane Wesssels
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/http.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/http.c,v
retrieving revision 1.1.1.3.4.1.2.1
retrieving revision 1.1.1.3.4.1.2.2
diff -u -r1.1.1.3.4.1.2.1 -r1.1.1.3.4.1.2.2
--- squid/src/http.c	14 Apr 2000 23:09:53 -0000	1.1.1.3.4.1.2.1
+++ squid/src/http.c	17 Apr 2000 00:13:10 -0000	1.1.1.3.4.1.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: http.c,v 1.1.1.3.4.1.2.1 2000/04/14 23:09:53 hno Exp $
+ * $Id: http.c,v 1.1.1.3.4.1.2.2 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 11    Hypertext Transfer Protocol (HTTP)
  * AUTHOR: Harvest Derived
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -392,6 +392,9 @@
 		httpState->request->host, skew);
     }
     ctx_exit(ctx);
+#if HEADERS_LOG
+    headersLog(1, 0, httpState->request->method, reply);
+#endif
 }
 
 static int
@@ -586,6 +589,9 @@
     ErrorState *err;
     debug(11, 5) ("httpSendComplete: FD %d: size %d: errflag %d.\n",
 	fd, size, errflag);
+#if URL_CHECKSUM_DEBUG
+    assert(entry->mem_obj->chksum == url_checksum(entry->mem_obj->url));
+#endif
     if (size > 0) {
 	fd_bytes(fd, size, FD_WRITE);
 	kb_incr(&Counter.server.all.kbytes_out, size);
Index: squid/src/icmp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/icmp.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.16.1
diff -u -r1.1.1.2 -r1.1.1.2.16.1
--- squid/src/icmp.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/icmp.c	17 Apr 2000 00:13:10 -0000	1.1.1.2.16.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: icmp.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: icmp.c,v 1.1.1.2.16.1 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 37    ICMP Routines
  * AUTHOR: Duane Wessels
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/icp_v2.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/icp_v2.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.10.1
diff -u -r1.1.1.3 -r1.1.1.3.10.1
--- squid/src/icp_v2.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/icp_v2.c	17 Apr 2000 00:13:10 -0000	1.1.1.3.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: icp_v2.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: icp_v2.c,v 1.1.1.3.10.1 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 12    Internet Cache Protocol
  * AUTHOR: Duane Wessels
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/icp_v3.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/icp_v3.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.10.1
diff -u -r1.1.1.3 -r1.1.1.3.10.1
--- squid/src/icp_v3.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/icp_v3.c	17 Apr 2000 00:13:10 -0000	1.1.1.3.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: icp_v3.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: icp_v3.c,v 1.1.1.3.10.1 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 12    Internet Cache Protocol
  * AUTHOR: Duane Wessels
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/ident.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ident.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.10.1
diff -u -r1.1.1.3 -r1.1.1.3.10.1
--- squid/src/ident.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/ident.c	17 Apr 2000 00:13:10 -0000	1.1.1.3.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ident.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: ident.c,v 1.1.1.3.10.1 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 30    Ident (RFC 931)
  * AUTHOR: Duane Wessels
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/internal.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/internal.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.10.1
diff -u -r1.1.1.3 -r1.1.1.3.10.1
--- squid/src/internal.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/internal.c	17 Apr 2000 00:13:10 -0000	1.1.1.3.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: internal.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: internal.c,v 1.1.1.3.10.1 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 76    Internal Squid Object handling
  * AUTHOR: Duane, Alex, Henrik
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/ipc.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ipc.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.12.1
diff -u -r1.1.1.3 -r1.1.1.3.12.1
--- squid/src/ipc.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/ipc.c	17 Apr 2000 00:13:10 -0000	1.1.1.3.12.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ipc.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: ipc.c,v 1.1.1.3.12.1 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 54    Interprocess Communication
  * AUTHOR: Duane Wessels
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/ipcache.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ipcache.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.10.1
diff -u -r1.1.1.3 -r1.1.1.3.10.1
--- squid/src/ipcache.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
+++ squid/src/ipcache.c	17 Apr 2000 00:13:10 -0000	1.1.1.3.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ipcache.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
+ * $Id: ipcache.c,v 1.1.1.3.10.1 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 14    IP Cache
  * AUTHOR: Harvest Derived
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
Index: squid/src/leakfinder.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/leakfinder.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.14.1
diff -u -r1.1.1.1 -r1.1.1.1.14.1
--- squid/src/leakfinder.c	26 Jan 2000 03:23:10 -0000	1.1.1.1
+++ squid/src/leakfinder.c	17 Apr 2000 00:13:10 -0000	1.1.1.1.14.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: leakfinder.c,v 1.1.1.1 2000/01/26 03:23:10 hno Exp $
+ * $Id: leakfinder.c,v 1.1.1.1.14.1 2000/04/17 00:13:10 hno Exp $
  *
  * DEBUG: section 45    Callback Data Registry
  * AUTHOR: Duane Wessels
@@ -12,10 +12,10 @@
  *  Internet community.  Development is led by Duane Wessels of the
  *  National Laboratory for Applied Network Research and funded by the
  *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  Duane Wessels and the University of California San Diego.  Please
- *  see the COPYRIGHT file for full details.  Squid incorporates
- *  software developed and/or copyrighted by other sources.  Please see
- *  the CREDITS file for full details.
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -98,7 +98,7 @@
 }
 
 void *
-leakFree(void *p)
+leakFreeFL(void *p, const char *file, int line)
 {
     ptr *c = (ptr *) hash_lookup(htable, p);
     assert(p);
--- /dev/null	Wed Feb 14 00:42:24 2007
+++ squid/src/logfile.c	Wed Feb 14 00:43:25 2007
@@ -0,0 +1,153 @@
+/*
+ * $Id$
+ */
+
+#include "squid.h"
+
+static void logfileWriteWrapper(Logfile * lf, const void *buf, size_t len);
+
+Logfile *
+logfileOpen(const char *path, size_t bufsz)
+{
+    int fd;
+    Logfile *lf;
+    fd = file_open(path, O_WRONLY | O_CREAT);
+    if (DISK_ERROR == fd) {
+	if (ENOENT == errno) {
+	    fatalf("Cannot open '%s' because\n"
+		"\tthe parent directory does not exist.\n"
+		"\tPlease create the directory.\n", path);
+	} else if (EACCES == errno) {
+	    fatalf("Cannot open '%s' for writing.\n"
+		"\tThe parent directory must be writeable by the\n"
+		"\tuser '%s', which is the cache_effective_user\n"
+		"\tset in squid.conf.", path, Config.effectiveUser);
+	} else {
+	    debug(50, 1) ("logfileOpen: %s: %s\n", path, xstrerror());
+	    return NULL;
+	}
+    }
+    lf = xcalloc(1, sizeof(*lf));
+    lf->fd = fd;
+    xstrncpy(lf->path, path, MAXPATHLEN);
+    if (bufsz > 0) {
+	lf->buf = xmalloc(bufsz);
+	lf->bufsz = bufsz;
+    }
+    return lf;
+}
+
+void
+logfileClose(Logfile * lf)
+{
+    logfileFlush(lf);
+    file_close(lf->fd);
+    if (lf->buf)
+	xfree(lf->buf);
+    xfree(lf);
+}
+
+void
+logfileRotate(Logfile * lf)
+{
+    struct stat sb;
+    int i;
+    char from[MAXPATHLEN];
+    char to[MAXPATHLEN];
+    assert(lf->path);
+#ifdef S_ISREG
+    if (stat(lf->path, &sb) == 0)
+	if (S_ISREG(sb.st_mode) == 0)
+	    return;
+#endif
+    debug(0, 1) ("logfileRotate: %s\n", lf->path);
+    /* Rotate numbers 0 through N up one */
+    for (i = Config.Log.rotateNumber; i > 1;) {
+	i--;
+	snprintf(from, MAXPATHLEN, "%s.%d", lf->path, i - 1);
+	snprintf(to, MAXPATHLEN, "%s.%d", lf->path, i);
+	xrename(from, to);
+    }
+    /* Rotate the current log to .0 */
+    logfileFlush(lf);
+    file_close(lf->fd);		/* always close */
+    if (Config.Log.rotateNumber > 0) {
+	snprintf(to, MAXPATHLEN, "%s.%d", lf->path, 0);
+	xrename(lf->path, to);
+    }
+    /* Reopen the log.  It may have been renamed "manually" */
+    lf->fd = file_open(lf->path, O_WRONLY | O_CREAT);
+    if (DISK_ERROR == lf->fd) {
+	debug(50, 1) ("logfileRotate: %s: %s\n", lf->path, xstrerror());
+	fatalf("Cannot open %s: %s", lf->path, xstrerror());
+    }
+}
+
+void
+logfileWrite(Logfile * lf, void *buf, size_t len)
+{
+    if (0 == lf->bufsz) {
+	/* buffering disabled */
+	logfileWriteWrapper(lf, buf, len);
+	return;
+    }
+    if (lf->offset > 0 && lf->offset + len > lf->bufsz)
+	logfileFlush(lf);
+    if (len > lf->bufsz) {
+	/* too big to fit in buffer */
+	logfileWriteWrapper(lf, buf, len);
+    }
+    /* buffer it */
+    xmemcpy(lf->buf + lf->offset, buf, len);
+    lf->offset += len;
+    assert(lf->offset <= lf->bufsz);
+}
+
+void
+#if STDC_HEADERS
+logfilePrintf(Logfile * lf, const char *fmt,...)
+#else
+logfilePrintf(va_alist)
+     va_dcl
+#endif
+{
+    va_list args;
+    char buf[8192];
+    int s;
+#if STDC_HEADERS
+    va_start(args, fmt);
+#else
+    Logfile *lf;
+    const char *fmt;
+    va_start(args);
+    lf = va_arg(args, Logfile *);
+    fmt = va_arg(args, char *);
+#endif
+    s = vsnprintf(buf, 8192, fmt, args);
+    logfileWrite(lf, buf, (size_t) s);
+    va_end(args);
+}
+
+void
+logfileFlush(Logfile * lf)
+{
+    if (0 == lf->offset)
+	return;
+    logfileWriteWrapper(lf, lf->buf, (size_t) lf->offset);
+    lf->offset = 0;
+}
+
+/*
+ * Aborts with fatal message if write() returns something other
+ * than its length argument.
+ */
+static void
+logfileWriteWrapper(Logfile * lf, const void *buf, size_t len)
+{
+    int s;
+    s = write(lf->fd, buf, len);
+    fd_bytes(lf->fd, len, FD_WRITE);
+    if (s == len)
+	return;
+    fatalf("logfileWrite: %s: %s\n", lf->path, xstrerror());
+}
